// Macbeeline Common lib 0.3

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};


function limit_3 (val, min, max) {
    return val < min ? min : (val > max ? max : val);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}


function mousemove (event) {
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event) {
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}


function showbackside(event) {
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	onhide();
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	


	document.getElementById('fliprollie').style.display = 'none';
}

function goToUrlFromBack(url) {
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	setTimeout ('flipitback();', 0);
	front.style.display="block";
    back.style.display="none";
	if (window.widget) widget.openURL(url);
}


function doneClicked() {
        var front = document.getElementById("front");
        var back = document.getElementById("behind");

        if (window.widget)
                widget.prepareForTransition("ToFront");


        front.style.display="block";
        back.style.display="none";

        setTimeout ('flipitback();', 0);
        almostDone();
}

function flipitback() {
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
}

function onshow() {
	willShow();
}

function onhide () {
	willHide();
}

function prefskey(key) {
	if (window.widget) {
		return widget.identifier + "-" + key;
	}
}

function onremove () {
	if (window.widget) {
		willRemove();
	}
}

function checkers(id) {
	document.getElementById(id).click();
}


function getLocalizedString(key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined) {
            ret = key;
        }
        return ret;
    } catch (ex) {}
    return key;
}
